<?php
class Avalon_Custompaymentmethodtbigr_IndexController extends Mage_Core_Controller_Front_Action
{

    public function indexAction()
    {
		$tbigr_encrypt = isset($_GET['enc']) ? str_replace("%3D", "=", urlencode($_GET['enc'])) : '';
		$tbigr_envurl = isset($_GET['envurl']) ? $_GET['envurl'] : '';
		$tbi_pause_txt = isset($_GET['tbi_pause_txt']) ? $_GET['tbi_pause_txt'] : '';
		$tbigr_type = isset($_GET['type']) ? $_GET['type'] : 'TBI';
		
		$send_tbigr = $_SESSION['send_tbigr'];
		
		if ($tbigr_envurl != ''){
			echo '<style>';
			echo '#tbigrloaderpanel {';
			echo 'display: block;';
			echo 'position: fixed;';
			echo 'top:calc(100% / 2);';
			echo 'left:calc(100% / 2 - 200px);';
			echo 'background: white;';
			echo 'z-index:999;';
			echo 'border: 2px solid #f3f3f3;';
			echo 'width: 400px;';
			echo 'height: 90px;';
			echo '}';
			echo '#tbigrloader {';
			echo 'position: absolute;';
			echo 'top:10px;';
			echo 'left:10px;';
			echo 'border: 16px solid #f3f3f3;';
			echo 'border-radius: 50%;';
			echo 'border-top: 16px solid #f07524;';
			echo 'width: 40px;';
			echo 'height: 40px;';
			echo '-webkit-animation: spin 2s linear infinite; /* Safari */';
			echo 'animation: spin 2s linear infinite;';
			echo '}';
			echo '#tbigrloadertext {';
			echo 'position: absolute;';
			echo 'top: 0px;';
			echo 'left: 90px;';
			echo 'padding:10px;';
			echo 'width: 100% - 90px;';
			echo 'font-size: 12px;';
			echo 'font-weight: bold;';
			echo 'text-align: center;';
			echo 'color: #f07524;';
			echo '}';
			echo '#tbigrloaderimg {';
			echo 'position: absolute;';
			echo 'top:45px;';
			echo 'width: 100%;';
			echo 'text-align: center;';
			echo '}';
			echo '/* Safari */';
			echo '@-webkit-keyframes spin {';
			echo '0% { -webkit-transform: rotate(0deg); }';
			echo '100% { -webkit-transform: rotate(360deg); }';
			echo '}';
			echo '@keyframes spin {';
			echo '0% { transform: rotate(0deg); }';
			echo '100% { transform: rotate(360deg); }';
			echo '}';
			echo '</style>';
			echo '<div id="tbigrloaderpanel">';
			echo '<div id="tbigrloader"></div>';
			echo '<div id="tbigrloadertext">' . $tbi_pause_txt . '</div>';
			echo '<div id="tbigrloaderimg"><img src="' . Mage::getBaseUrl(Mage_Core_Model_Store::URL_TYPE_MEDIA) . 'keys/logo.png" alt="tbi bank" /></div>';
			echo '</div>';		
		}else{
			echo '<p style="text-align:center;font-weight:bold;font-size:130%;">' . $this->__('The Active environment field is empty!') . '</p>';
		}
		
		if (($tbigr_encrypt != '') && ($send_tbigr == 'No')){
			$_SESSION['send_tbigr'] = 'Yes';
			
			$tbigr_plaintext = base64_decode($tbigr_encrypt);
			
			if ($tbigr_type == 'TBI'){
				if ($tbigr_envurl != ''){
					if (Mage::getStoreConfig('avalon_custompaymentmethodtbigr_tab_options/properties_all/grtbi_username')){
						$tbigr_username = Mage::getStoreConfig('avalon_custompaymentmethodtbigr_tab_options/properties_all/grtbi_username');
					}else{
						$tbigr_username = "";
					}	
					if (Mage::getStoreConfig('avalon_custompaymentmethodtbigr_tab_options/properties_all/grtbi_password')){
						$tbigr_password = Mage::getStoreConfig('avalon_custompaymentmethodtbigr_tab_options/properties_all/grtbi_password');
					}else{
						$tbigr_password = "";
					}
					$tbigr_env = isset($_GET['tbigr_env']) ? $_GET['tbigr_env'] : 'tbi_test';
					if ($tbigr_env == 'tbi_test'){
						$tbigr_ocp = '1f0a04a6ad7a4dac80c664706fdcb93c';
					}else{
						$tbigr_ocp = 'd2304c1fe5de43d8837d081192a9a39b';
					}
					
					$curl_token = curl_init();
					curl_setopt_array($curl_token, array(
						CURLOPT_URL 			=> $tbigr_envurl . '/User/authorize',
						CURLOPT_RETURNTRANSFER 	=> true,
						CURLOPT_ENCODING 		=> '',
						CURLOPT_MAXREDIRS 		=> 4,
						CURLOPT_TIMEOUT 		=> 0,
						CURLOPT_FOLLOWLOCATION 	=> true,
						CURLOPT_HTTP_VERSION 	=> CURL_HTTP_VERSION_1_1,
						CURLOPT_CUSTOMREQUEST 	=> 'POST',
						CURLOPT_POSTFIELDS 		=>'{"username":"' . $tbigr_username . '","password":"' . $tbigr_password . '"}',
						CURLOPT_HTTPHEADER 		=> array(
							'Content-Type: application/json',
							'Ocp-Apim-Subscription-Key: ' . $tbigr_ocp,
							'Ocp-Apim-Trace: true'
						),
					));
					$response_token = curl_exec($curl_token);
					curl_close($curl_token);
					
					$tbigr_token = json_decode($response_token);
					
					if (!empty($tbigr_token->token)){
						$curl_application = curl_init();
						curl_setopt_array($curl_application, array(
							CURLOPT_URL => $tbigr_envurl . '/Application',
							CURLOPT_RETURNTRANSFER => true,
							CURLOPT_ENCODING => '',
							CURLOPT_MAXREDIRS => 4,
							CURLOPT_TIMEOUT => 0,
							CURLOPT_FOLLOWLOCATION => true,
							CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
							CURLOPT_CUSTOMREQUEST => 'POST',
							CURLOPT_POSTFIELDS => $tbigr_plaintext,
							CURLOPT_HTTPHEADER => array(
								'Content-Type: application/json',
								'Ocp-Apim-Subscription-Key: ' . $tbigr_ocp,
								'Ocp-Apim-Trace: true',
								'AuthorizationToken: ' . $tbigr_token->token
							),
						));
						$response_application = curl_exec($curl_application);
						curl_close($curl_application);
						$tbigr_result = json_decode($response_application);
						
						if (property_exists($tbigr_result, 'ErrorCode') && $tbigr_result->ErrorCode == NULL){
							$tbigr_url = $tbigr_result->Url;
							echo '<script>';
							echo 'window.location.href = "' . $tbigr_url . '"';
							echo '</script>';
							//var_dump($tbigr_plaintext);
							//var_dump($tbigr_result);
							//die;
						}
					}
				}
			}
			
			if ($tbigr_type == 'IRIS'){
				if ($tbigr_envurl != ''){
					if (Mage::getStoreConfig('avalon_custompaymentmethodtbigr_tab_options/properties_all/griris_key')){
						$tbigr_iris_key = Mage::getStoreConfig('avalon_custompaymentmethodtbigr_tab_options/properties_all/griris_key');
					}else{
						$tbigr_iris_key = "";
					}
					
					$curl_application = curl_init();
						curl_setopt_array($curl_application, array(
						CURLOPT_URL => $tbigr_envurl . '/' . $tbigr_iris_key,
						CURLOPT_RETURNTRANSFER => true,
						CURLOPT_ENCODING => '',
						CURLOPT_MAXREDIRS => 4,
						CURLOPT_TIMEOUT => 0,
						CURLOPT_FOLLOWLOCATION => true,
						CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
						CURLOPT_CUSTOMREQUEST => 'POST',
						CURLOPT_POSTFIELDS => $tbigr_plaintext,
						CURLOPT_HTTPHEADER => array(
							'Content-Type: application/json'
						),
					));
					$response_application = curl_exec($curl_application);
					curl_close($curl_application);
					$tbigriris_result = json_decode($response_application);
					if (property_exists($tbigriris_result, 'paymentLink')){
						$tbigriris_url = $tbigriris_result->paymentLink;
						echo '<script>';
						echo 'window.location.href = "' . $tbigriris_url . '"';
						echo '</script>';
						//var_dump($tbigriris_plaintext);
						//var_dump($tbigriris_result);
						//die;
					}
				}
			}		
		}
    }
	
	public function orderupdateAction() {
		$json = array();
		$json['success'] = 'unsuccess';
		
		if (Mage::getStoreConfig('avalon_custompaymentmethodtbigr_tab_options/properties_all/grtbi_unicid')){
			$tbigr_unicid = Mage::getStoreConfig('avalon_custompaymentmethodtbigr_tab_options/properties_all/grtbi_unicid');
		}else{
			$tbigr_unicid = "";
		}
			
		if (NULL != $this->getRequest()->getPost('order_id')) {
			$tbigr_order_id = $this->getRequest()->getPost('order_id');
		} else {
			$tbigr_order_id = '';
		}
		if (NULL != $this->getRequest()->getPost('status')) {
			$tbigr_status = $this->getRequest()->getPost('status');
		} else {
			$tbigr_status = '';
		}
		if (NULL != $this->getRequest()->getPost('calculator_id')) {
			$tbigr_calculator_id = $this->getRequest()->getPost('calculator_id');
		} else {
			$tbigr_calculator_id = '';
		}
		
		if (($tbigr_calculator_id != '') && ($tbigr_unicid == $tbigr_calculator_id)){
			$resource = Mage::getSingleton('core/resource');
			$writeConnection = $resource->getConnection('core_write');
			$table = $resource->getTableName('sales_flat_order_grid');
			$query = "UPDATE {$table} SET tbigr_status = '{$tbigr_status}' WHERE increment_id = " . (int)$tbigr_order_id;
			$writeConnection->query($query);
			$json['success'] = 'success';
		}
				
		$json['tbigr_order_id'] = $tbigr_order_id;
		$json['tbigr_status'] = $tbigr_status;
		$json['tbigr_calculator_id'] = $tbigr_calculator_id;
		
		$this->getResponse()->clearHeaders()->setHeader('Content-type','application/json',true);
		$this->getResponse()->clearHeaders()->setHeader('Access-Control-Allow-Origin', Mage::helper('custompaymentmethodtbigr')->getTbigrLiveUrl());
        $this->getResponse()->setBody(json_encode($json));
    }
   
}